#include <bits/stdc++.h>

using namespace std;

/**
    Algorithm      : groups of 32 soldiers ; <O((N + Q) * (P / 32)), O(N + Q)>
    Expected score : 100p
    Author         : Alexandru Văleanu
**/

const int MAX_N = 50000;
const int MAX_P = 10000;
const int MAX_Q = 100000;
const int MAX_S = 300000 + 1;

const int NIL = -1;

struct Edge
{
    int v;
    int urm;
};

Edge lista[MAX_S];
int head[MAX_P];

pair<int,int> queries[MAX_Q];
int solution[MAX_Q];

unsigned army[MAX_N];

int N, Q;

int contor;

void addEdge(int x, int y)
{
    lista[contor] = {y, head[x]};
    head[x] = contor++;
}

int popcount(unsigned x)
{
    return __builtin_popcount(x);
}

int main()
{
    ifstream in("infinitywar.in");
    ofstream out("infinitywar.out");

    ios_base::sync_with_stdio(false);

    assert(in >> N);
    assert(in >> Q);

    for (int i = 0; i < MAX_P; ++i)
        head[i] = NIL;

    for (int i = 0; i < N; ++i)
    {
        int K;
        assert(in >> K);

        for (int j = 0; j < K; ++j)
        {
            int power;
            assert(in >> power);
            assert(power > 0);

            addEdge(power - 1, i);
        }
    }

    for (int i = 0; i < Q; ++i)
    {
        int x, y;
        assert(in >> x >> y);
        assert(1 <= x && x <= N);
        assert(1 <= y && y <= N);
        x--; y--;

        queries[i] = {x, y};
    }

    int toSubtract = 0;

    for (int i = 0; i < MAX_P; i += 32)
    {
        int x = i;
        int y = min(MAX_P - 1, i + 32 - 1);

        memset(army, 0, sizeof(army));

        for (int k = x; k <= y; ++k)
        {
            for (int p = head[k]; p != NIL; p = lista[p].urm)
            {
                int ind = lista[p].v;

                army[ind] ^= (1U << (k - toSubtract));
            }
        }

        for (int j = 1; j < N; ++j)
            army[j] ^= army[j - 1];

        for (int j = 0; j < Q; ++j)
        {
            int a = queries[j].first;
            int b = queries[j].second;

            unsigned answer = army[b];

            if (a > 0)
                answer ^= army[a - 1];

            solution[j] += popcount(answer);
        }

        toSubtract += 32;
    }

    for (int i = 0; i < Q; ++i)
        out << solution[i] << '\n';

    in.close();
    out.close();

    return 0;
}

