#include <bits/stdc++.h>

using namespace std;

/**
    Algorithm      : partial xor sum
    Expected score : 30p
    Author         : Alexandru Văleanu
**/

const int MAX_N = 10000;
const int MAX_P = 500;

bitset <MAX_P> sumXOR[MAX_N];
int N, Q;

int main()
{
    ifstream in("infinitywar.in");
    ofstream out("infinitywar.out");

    assert(in);

    ios_base::sync_with_stdio(false);

    assert(in >> N);
    assert(in >> Q);

    for (int i = 0; i < N; ++i)
    {
        int K;
        assert(in >> K);

        for (int j = 0; j < K; ++j)
        {
            int power;
            assert(in >> power);
            assert(sumXOR[i].test(power - 1) == false);
            assert(power > 0);

            sumXOR[i].set(power - 1);
        }
    }

    for (int i = 1; i < N; ++i)
        sumXOR[i] ^= sumXOR[i - 1];

    for (int i = 0; i < Q; ++i)
    {
        int x, y;
        assert(in >> x >> y);
        assert(1 <= x && x <= N);
        assert(1 <= y && y <= N);
        x--; y--;

        bitset<MAX_P> solution = sumXOR[y];

        if (x > 0)
            solution ^= sumXOR[x - 1];

        out << solution.count() << '\n';
    }

    in.close();
    out.close();

    return 0;
}

